//Assignment 1b - Woohun Joo

//font
PFont myFont;

//Layout Variable
int horMargin = 100;
int verMargin = 150;

//2D matrix variables
Table table;
int numRows, numColumns;
float[][] dataMatrix;
float maxValue, minValue;

//Cell Distance
int cellDist = 0;

//cell width, height
float cellWidth, cellHeight;

//year labels
int startYear = 2009;

//normalization, color, reorder status
boolean normalization = false;
boolean colorApplied = false;
boolean reorder = false;

//month
String [] Month = {"Jan","Feb","Mar","Apr","May","Jun", "Jul","Aug","Sep","Oct","Nov","Dec"};
int numMonth = 12;

//month
String [] Number = {"1","2","3","4","5","6"};
int numNumber = 6;

void setup() {
  
  smooth();
  size(1280, 720);
  
  //font
  myFont =createFont("Helvetica", 38);
  textFont(myFont);
  
  //resize option
  surface.setResizable(true);
  
  //load csv file
  table = loadTable("assignment1b.csv", "header");
  
  //get the number of rows and cols
  numRows = table.getRowCount();
  numColumns = table.getColumnCount();
  
  //dataMatix = Float Array
  dataMatrix = new float[numColumns-2][numRows];
  println("Rows: " + numRows + " Columns: " + numColumns);
  
  //get max and min value 
  for(int i=0; i<numColumns-2; i++){
    for(int j=0; j<numRows; j++){
      dataMatrix[i][j] = table.getFloat(j, i+2);
    }
  }
  
  maxValue = max2D(dataMatrix);
  minValue = min2D(dataMatrix);
  
  println("Max Value " + maxValue);
  println("Min Value " + minValue);

}

//Refresh the canvas every frame
void draw() {  
  //background color
  background(40, 40, 40);
  
  //calculate width and height for each cell
  cellWidth = (width-2*horMargin)/(numRows);
  cellHeight = (height-2*verMargin)/(numColumns-2);
  
  colorMode(HSB, 360, 100, 100);
  
  //drawing 2d matrix on canvas
  for(int i=0; i<numColumns-2; i++){
    float xTrans = 0;
    for(int j=0; j<numRows; j++){
      
      float sat = map(dataMatrix[i][j], minValue, maxValue,30,100);
      
      float bri = 100;
      //stroke(77, 77, 77);
      noStroke();
      
      if(i == 0){
        fill(0, sat, bri);
      } else if(i == 1) {
        fill(120, sat, bri);
      } else if(i == 2) {
        fill(40, sat, bri);
      } else if(i == 3) {
        fill(240, sat, bri);
      } else if(i == 4) {
        fill(180, sat, bri);
      } else if(i == 5) {
        fill(299, sat, bri);
      } else {
        fill(0, 0, 0);
      }

      pushMatrix();
      //translate(xTrans, 0);
      rect(horMargin + cellWidth*j, verMargin + cellHeight*i+25, cellWidth, cellWidth);
      popMatrix();
      
      }
   }
   colorMode(RGB, 255, 255, 255);
   
   //add vertical lables
   for(int i = 0; i < numColumns-2; i++){  
     textAlign(RIGHT, CENTER);
     fill(255);
     textSize(12);
     //question?
     text(startYear+i, horMargin-15, verMargin-3 + cellHeight/2 + cellHeight*i);
   }
   colorMode(HSB, 360, 100, 100);
   for(int i = 0; i < 12; i++){
     for(int j=0; j<1; j++){
        //text(Number[i], horMargin+5, verMargin+400);
     }
   }
   
   colorMode(RGB, 255, 255, 255);
   //title text
   textAlign(CENTER, CENTER);
   textSize(15);
   
    
    //month Text
   for(int p = 0; p < numMonth; p++){
      fill(255);
      textAlign(LEFT, CENTER);
      textSize(14);
      text(Month[p], p*90+horMargin, verMargin - 5);
    }
    
    //number text
    //for(int q = 0; q < numNumber; q++){
    //  textAlign(LEFT, CENTER);
    //  textSize(10);
    //  text(Number[q], q*15+horMargin+5, verMargin+400);
    //  text(Number[q], q*15+horMargin+5, verMargin+400);
    //  text(Number[q], q*15+horMargin+5, verMargin+400);
    //}
    
      
      textSize(36);
      text("Travel Book Checkouts", horMargin+3, verMargin-70);
      textSize(10);
      textAlign(LEFT, CENTER);
      //text("Europe", horMargin+15, verMargin+155);
      //text("Asia", horMargin+15, verMargin+175);
      //text("Africa", horMargin+15, verMargin+195);
      //text("N.America", horMargin+15, verMargin+215);
      //text("S.America", horMargin+15, verMargin+235);
      //text("etc.", horMargin+15, verMargin+255);
    
    if(normalization == true) normalization();
    else if(normalization == false) resetData();
  
    if(reorder == true) reorder();
    if(colorApplied == true) colorScheme();
  
}